unit MainChartUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Vcl.ExtCtrls, Vcl.DBCtrls,
  Vcl.Grids, Vcl.DBGrids, IBX.IBCustomDataSet, IBX.IBDatabase, Vcl.StdCtrls,
  IBX.IBQuery, VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart, VCLTee.DBChart, VCLTee.Series;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBDataSet1: TIBDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    IBDataSet1STATE_ABBREVIATION: TIBStringField;
    IBDataSet1STATE_NAME: TIBStringField;
    IBQuery1: TIBQuery;
    Button1: TButton;
    Edit1: TEdit;
    IBQuery1STATE_ABBREVIATION: TIBStringField;
    IBQuery1CENSUS_YEAR: TIBStringField;
    IBQuery1POPULATION: TIBStringField;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Panel1: TPanel;
    Panel3: TPanel;
    DBChart1: TDBChart;
    Series1: TBarSeries;
    procedure Button1Click(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Chart population growth for a selected (in grid1 and edit1) state
  //  Note: you can override selected state typing in the edit1
  IBQuery1.Close();
  IBQuery1.ParamByName('StateAbbreviation').AsString := Edit1.Text;
  IBQuery1.Open();
  Series1.YValues.ValueSource := 'POPULATION';
  // Series1.XLabelsSource := 'CENSUS_YEAR';
  Series1.DataSource := IBQuery1;
  Series1.CheckDataSource;
end;

procedure TForm1.DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
begin
  // put selected state abbreviation in the edit1
  Edit1.text := IBDataSet1STATE_ABBREVIATION.AsString;
  IBQuery1.Close();
  IBQuery1.ParamByName('StateAbbreviation').AsString := Edit1.Text;
  IBQuery1.Open();
  Series1.YValues.ValueSource := 'POPULATION';
  // Series1.XLabelsSource := 'CENSUS_YEAR';
  Series1.DataSource := IBQuery1;
  Series1.CheckDataSource;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  // set first state in the edit1
  Edit1.text := IBDataSet1STATE_ABBREVIATION.AsString;
end;

end.
