unit MainUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DBXInterBase, Data.DB, Data.SqlExpr,
  Data.FMTBcd, Datasnap.DBClient, Datasnap.Provider, Vcl.StdCtrls, Vcl.Grids,
  Vcl.DBGrids, Vcl.DBCtrls;

type
  TForm1 = class(TForm)
    BrazilDatabase: TSQLConnection;
    BrazilStatesQuery: TSQLQuery;
    StatesDataSetProvider: TDataSetProvider;
    BrazilStatesQuerySTATE_ABBREVIATION: TStringField;
    BrazilStatesQuerySTATE_NAME: TStringField;
    BrazilStatesQueryPATH_DATA: TMemoField;
    BrazilStatesQuerySTATE_GRAPHIC: TBlobField;
    StatesClientDataSet: TClientDataSet;
    StatesClientDataSetSTATE_ABBREVIATION: TStringField;
    StatesClientDataSetSTATE_NAME: TStringField;
    StatesClientDataSetPATH_DATA: TMemoField;
    StatesClientDataSetSTATE_GRAPHIC: TBlobField;
    StatesDataSource: TDataSource;
    DBGrid1: TDBGrid;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    DBMemo1: TDBMemo;
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  StatesClientDataSet.SaveToFile('BrazilStates.cds');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  StatesClientDataSet.Active := false;
  StatesClientDataSet.LoadFromFile('BrazilStates.cds');
  StatesClientDataSet.Active := true;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Checkbox1.Checked then begin
    BrazilDatabase.Connected := true;
    BrazilStatesQuery.Active := true;
    StatesClientDataSet.Active := true;
    Button1.Enabled := true;
  end
  else begin
    Button1.Enabled := false;
    StatesClientDataSet.Active := false;
    BrazilStatesQuery.Active := false;
    BrazilDatabase.Connected := false;
  end;
end;

end.
